Main Page Modules Data Structures File List Data Fields Globals

# Reading key presses

How to read key presses from the braille terminal. More...

## Data Structures
struct | brlapi_keybinding_t
| Key binding structure. More...
## Defines
#define | BRL_KEYBUF_SIZE 256
#define | BRL_KEYCODE_MAX ((brl_keycode_t) (UINT32_MAX))
#define | BRLAPI_HOMEKEYDIR ".brlkeys"
#define | BRLAPI_HOMEKEYEXT ".kbd"
#define | BRLAPI_ETCKEYFILE "brlkeys"
## Typedefs
typedef uint32_t | brl_keycode_t
## Functions
int | brlapi_readKey (int block, brl_keycode_t *code)
int | brlapi_readCommand (int block, brl_keycode_t *code)
int | brlapi_readBinding (int block, const char **code)
int | brlapi_ignoreKeys (brl_keycode_t x, brl_keycode_t y)
int | brlapi_unignoreKeys (brl_keycode_t x, brl_keycode_t y)

## Detailed Description

Once brlapi_getTty() is called, the application can call brlapi_readKey(), brlapi_readCommand() or brlapi_readBinding() to read key presses. Not everyone can be called, it depends on parameters given to brlapi_getTty().

key presses are buffered, so that calling brlapi_readKey() in non-blocking mode from times to times should suffice.

## Define Documentation

#define BRL_KEYBUF_SIZE 256

| buffer size key presses won't be lost provided no more than BRL_KEYBUF_SIZE key presses are done between two calls to brlapi_read* if a call to another function is done in the meanwhile (which needs somewhere to put them before being able to get responses from the server)

#define BRL_KEYCODE_MAX ((brl_keycode_t) (UINT32_MAX))

| brl_keycode_t's biggest value As defined in `<inttypes.h>`

#define BRLAPI_ETCKEYFILE "brlkeys"

| Prefix for driver-dependent key names header files Driver-dependent key names header files are stored in BRLAPI_ETCDIR/BRLAPI_ETCKEYFILE-xy.h where `xy` is the driver code, as returned by brlapi_getDriverId()

#define BRLAPI_HOMEKEYDIR ".brlkeys"

| BrlAPI 's $HOME settings directory this directory will contain per-user configuration

#define BRLAPI_HOMEKEYEXT ".kbd"

| BrlAPI 's key binding suffix

## Typedef Documentation

typedef uint32_t brl_keycode_t

| type for key codes Its size is 32 bits, so driver implementors have to restrict themselves to a 32 bit space.

## Function Documentation

int brlapi_ignoreKeys | ( | brl_keycode_t | x,
|  | brl_keycode_t | y
| ) |

| Ignore some key presses from the braille keyboard This function asks the server to give keys between x and y to brltty, rather than returning them to the application via brlapi_read(Key|Command|Binding)() Note: The given codes are either raw keycodes if BRLKEYCODES was given to brlapi_getTty(), or brltty commands if BRLCOMMANDS was given.

int brlapi_readBinding | ( | int | block,
|  | const char ** | code
| ) |

  | read a key binding from the braille keyboard This function returns a command name, as bound in user's configuration file: if the read is successful, a pointer on a string is returned, this is the string defined in $HOME/.brlkeys/appli-xy.kbd for the key which was read, else `NULL` is returned Parameters:
  block | tells whether the call should block until a key is pressed (1) or should only probe key presses (0).
  code | holds the key string if a key press is indeed read.
It can be called only if a brlapi_keybinding_t structure was filled and given to brlapi_getTty() Returns: -1 on error and *code is then undefined, 0 if block was 0 and no key was pressed so far, or 1 and *code holds the key string.

int brlapi_readCommand | ( | int | block,
|  | brl_keycode_t * | code
| ) |

  | Read a command from the braille keyboard This function returns brltty commands, as described in `<brltty/brldefs.h>` . These are hence pretty driver-independent, and should be used by default when no other option is possible. It can be called only if BRLCOMMANDS was given to brlapi_getTty() By default, all commands but those which restart drivers and switch virtual terminals are returned to the application and not to brltty. If the application doesn't want to see some command events, it should call brlapi_ignoreKeys() Parameters:
  block | tells whether the call should block until a key is pressed (1) or should only probe key presses (0).
  code | holds the command code if a key press is indeed read.
Returns: -1 on error and *code is then undefined, 0 if block was 0 and no key was pressed so far, or 1 and *code holds the command code.

int brlapi_readKey | ( | int | block,
|  | brl_keycode_t * | code
| ) |

  | Read a key from the braille keyboard This function returns raw keycodes, as specified by the terminal driver. It generally corresponds to the code the terminal tells to the driver. This should only be used to application which are dedicated to a particular braille terminal. Hence, checking the terminal type thanks to a call to brlapi_getDriverId() or even brlapi_getDriverName() before getting tty control is a pretty good idea. It can be called only if BRLKEYCODES was given to brlapi_getTty() By default, all the keypresses will be passed to the client, none will go through brltty, so the application will have to handle console switching itself. Parameters:
  block | tells whether the call should block until a key is pressed (1) or should only probe key presses (0),
  code | holds the key code if a key press is indeed read.
Returns: -1 on error and *code is then undefined, 0 if block was 0 and no key was pressed so far, or 1 and *code holds the key code.

int brlapi_unignoreKeys | ( | brl_keycode_t | x,
|  | brl_keycode_t | y
| ) |

| Unignore some key presses from the braille keyboard This function asks the server to return keys between x and y to the application, and not give them to brltty. Note: You shouldn't ask the server to give you key presses which are usually used to switch between TTYs, unless you really know what you are doing ! Note: The given codes are either raw keycodes if BRLKEYCODES was given to brlapi_getTty(), or brltty commands if BRLCOMMANDS was given.